*!*********************************************************************
*!
*!       Function: BAR_CODE()
*!
*!          Calls: PRINTCODE()    (function  in BARPROCS.PRG)
*!
*!*********************************************************************

FUNCTION bar_code

PARAMETERS x_text

x_code = ""
FOR H = 1 TO 3
  FOR I = 1 TO LEN(x_text)
    x_letter = SUBSTR(x_text,I,1)
    x_code = IF(AT(x_letter,chars)=0,x_letter,char[AT(x_letter,chars)]) + ns
    printcode(CHR(27) + CHR(76) + CHR(n1) + CHR(n2) + x_code)  && HiSpeed Double Density 120dpi
  NEXT
  * 23/216 line feed
  printcode(CHR(27)+CHR(74)+CHR(23)+CHR(13))
NEXT
* 5/216 line feed
printcode(CHR(27)+CHR(74)+CHR(5)+CHR(13))
* reset printer to 10cpi
printcode(CHR(27)+"@")
RETURN x_code

*!*********************************************************************
*!
*!      Procedure: SET_IBM
*!
*!          Calls: PRINTCODE()    (function  in BARPROCS.PRG)
*!
*!*********************************************************************

PROCEDURE set_ibm

public nb,wb,ns,ws,n1,n2

ns = CHR(0) + CHR(0)
ws = CHR(0) + CHR(0) + CHR(0) + CHR(0)
nb = CHR(255)
wb = CHR(255) + CHR(255) + CHR(255)
* SET printer to 2/216 lines per inch
printcode(CHR(27)+CHR(51)+CHR(2))
* calculate N1 and N2
cols = 21
n1 = cols % 256
n2 = INT(cols/256)

RETURN

*!*********************************************************************
*!
*!      Procedure: CNVT_CODE
*!
*!*********************************************************************

PROCEDURE cnvt_code

public char[44],chars

chars = "1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ-. *$/+%"
char[01] = wb+ns+nb+ws+nb+ns+nb+ns+wb       && Character "1"
char[02] = nb+ns+wb+ws+nb+ns+nb+ns+wb       && Character "2"
char[03] = wb+ns+wb+ws+nb+ns+nb+ns+nb       && Character "3"
char[04] = nb+ns+nb+ws+wb+ns+nb+ns+wb       && Character "4"
char[05] = wb+ns+nb+ws+wb+ns+nb+ns+nb       && Character "5"
char[06] = nb+ns+wb+ws+wb+ns+nb+ns+nb       && Character "6"
char[07] = nb+ns+nb+ws+nb+ns+wb+ns+wb       && Character "7"
char[08] = wb+ns+nb+ws+nb+ns+wb+ns+nb       && Character "8"
char[09] = nb+ns+wb+ws+nb+ns+wb+ns+nb       && Character "9"
char[10] = nb+ns+nb+ws+wb+ns+wb+ns+nb       && Character "0"
char[11] = wb+ns+nb+ns+nb+ws+nb+ns+wb       && Character "A"
char[12] = nb+ns+wb+ns+nb+ws+nb+ns+wb       && Character "B"
char[13] = wb+ns+wb+ns+nb+ws+nb+ns+nb       && Character "C"
char[14] = nb+ns+nb+ns+wb+ws+nb+ns+wb       && Character "D"
char[15] = wb+ns+nb+ns+wb+ws+nb+ns+nb       && Character "E"
char[16] = nb+ns+wb+ns+wb+ws+nb+ns+nb       && Character "F"
char[17] = nb+ns+nb+ns+nb+ws+wb+ns+wb       && Character "G"
char[18] = wb+ns+nb+ns+nb+ws+wb+ns+nb       && Character "H"
char[19] = nb+ns+wb+ns+nb+ws+wb+ns+nb       && Character "I"
char[20] = nb+ns+nb+ns+wb+ws+wb+ns+nb       && Character "J"
char[21] = wb+ns+nb+ns+nb+ns+nb+ws+wb       && Character "K"
char[22] = nb+ns+wb+ns+nb+ns+nb+ws+wb       && Character "L"
char[23] = wb+ns+wb+ns+nb+ns+nb+ws+nb       && Character "M"
char[24] = nb+ns+nb+ns+wb+ns+nb+ws+wb       && Character "N"
char[25] = wb+ns+nb+ns+wb+ns+nb+ws+nb       && Character "O"
char[26] = nb+ns+wb+ns+wb+ns+nb+ws+nb       && Character "P"
char[27] = nb+ns+nb+ns+nb+ns+wb+ws+wb       && Character "Q"
char[28] = wb+ns+nb+ns+nb+ns+wb+ws+nb       && Character "R"
char[29] = nb+ns+wb+ns+nb+ns+wb+ws+nb       && Character "S"
char[30] = nb+ns+nb+ns+wb+ns+wb+ws+nb       && Character "T"
char[31] = wb+ws+nb+ns+nb+ns+nb+ns+wb       && Character "U"
char[32] = nb+ws+wb+ns+nb+ns+nb+ns+wb       && Character "V"
char[33] = wb+ws+wb+ns+nb+ns+nb+ns+nb       && Character "W"
char[34] = nb+ws+nb+ns+wb+ns+nb+ns+wb       && Character "X"
char[35] = wb+ws+nb+ns+wb+ns+nb+ns+nb       && Character "Y"
char[36] = nb+ws+wb+ns+wb+ns+nb+ns+nb       && Character "Z"
char[37] = nb+ws+nb+ns+nb+ns+wb+ns+wb       && Character "-"
char[38] = wb+ws+nb+ns+nb+ns+wb+ns+nb       && Character "."
char[39] = nb+ws+wb+ns+nb+ns+wb+ns+nb       && Character " "
char[40] = nb+ws+nb+ns+wb+ns+wb+ns+nb       && Character "*"
char[41] = nb+ws+nb+ws+nb+ws+nb+ns+nb       && Character "$"
char[42] = nb+ws+nb+ws+nb+ns+nb+ws+nb       && Character "/"
char[43] = nb+ws+nb+ns+nb+ws+nb+ws+nb       && Character "+"
char[44] = nb+ns+nb+ws+nb+ws+nb+ws+nb       && Character "%"

RETURN

*!*********************************************************************
*!
*!       Function: PRINTCODE()
*!
*!      Called by: BAR_CODE()     (function  in BARPROCS.PRG)
*!               : SET_IBM        (procedure in BARPROCS.PRG)
*!
*!*********************************************************************

FUNCTION printcode

PARAMETERS x_code

SET CONSOLE (.F.)
SET PRINT (.T.)
?? x_code
SET PRINT (.F.)
SET CONSOLE (.T.)

RETURN .T.  &&x_null

*: EOF: BARPROCS.PRG
